
function checkresult(result) {
  
  if (result != "{}") {
      result = JSON.parse(result);
      // if(!result.message) {
        showresult(result);
      // }
  }
}
var displaystring = '';

function callapi(manifest) {
  var currentVersion = manifest.version;

  if (document.getElementById("PurpleLinks")) {
      var element = document.getElementById("PurpleLinks");
      element.parentNode.removeChild(element);
  }

  

  if (document.getElementById("Y_Ext")) {
      var element = document.getElementById("Y_Ext");
      element.parentNode.removeChild(element);
  }

  displaystring = '';

  var requestOptions = {
      method: 'GET',
      redirect: 'follow'
  };

  let requestURL = "https://edutestqa.appspot.com/admin/content/api/v1/getPurpleLinksInfoExtFull?o-url=" + window.location.href + "&version=" + currentVersion;
  // console.log(requestURL);
  fetch(requestURL, requestOptions)
      .then(response => response.text())
      .then(result => checkresult(result))
      .catch(error => console.log('error', error));
}

function showresult(result) {
  displaystring = '';
  if(result.message) {
    // no content message
    if(window.location.href.startsWith("https://www.youtube.com/")) {
      displaystring += '<div style="height: 80px;width: 95%;position: relative;top: 10px;box-shadow: rgba(0, 0, 0, 0.2) 0px 1px 3px;padding: 10px;border-radius: 23px !important;">';
      displaystring += '<div style="margin-right: 20px; text-align:center;"><span style="font-size: medium;"><b>' + result.message + '</b></span></div>';
      displaystring += '</div></div>';
      createpopup(displaystring, result);
      document.getElementById('Y_Ext_cpt').style.minHeight = "100px";
    }
  } else {
    var refresh_str = '';
    refresh_str += '<div id="PurpleLinks" style="text-align: center;padding: 10px;font-weight: bold;">';
    refresh_str += '<span>Want a refresher on any of the following: </span></br></br>'

    displaystring += '<span style="font-size: 22px;"><b id="referenceHeading">Want to know more about a term in the video?</b> <div class="loader" id="referenceHeadingLoader"><div class="color"></div></div></span>';
    displaystring += '<div id="" style="display:none">';
    displaystring += '<ul id="extmyUL_2">';
    var keys = Object.keys(result.purpleLinksInfoExtFull);
    for (var i = 0; i < keys.length; i++) {
        var key = keys[i];
        if (result.hasOwnProperty(key)) {
            displaystring += '<li>';
            displaystring += '<div class="purpleLinkPhrase caret">';
            displaystring += result[key]["purpleLinkPhrase"];
            refresh_str += '"'+result[key]["purpleLinkPhrase"]+'"';
            if(i != keys.length-1) {
              refresh_str += ',';
            }
            refresh_str += ' ';
            displaystring += '</div>';
            displaystring += '<ul class="nested">';
            for (var counter = 0; counter < result[key]["data"].length; counter++) {
                displaystring += '<li>';
                displaystring += '<div class="purpleLinkPhrase_sH">';
                displaystring += '<a target="_blank" href="' + result[key]["data"][counter]["url"] + '">' + result[key]["data"][counter]["sH"] + '</a>';
                displaystring += '</div>';
                displaystring += '</li>';
            }
            displaystring += '</ul>';
            displaystring += '</li>';
        }
    }
    refresh_str += '</br></br>';
    refresh_str += '<button id="y_details" type="button" style="';
    refresh_str += 'height: 30px;width:100px;';
    refresh_str += 'border-color: pink;';
    refresh_str += 'cursor: pointer;';
    displaystring += '</div>';
    refresh_str += '">Yes</button>';
    displaystring += '</ul>';
    displaystring += '<div id="v1"><span><img id="" src=" ' +chrome.runtime.getURL("icon/loupe.png") + '" width="20" height="20"></span><input type="text" autocomplete="off" id="userInputTerms" placeholder="Type phrase e.g. nested list & Press enter"></div>';
    displaystring += '<div id="v2" style="display:none"><ul id="matchedPurpleLinkResults">';
    displaystring += '</ul>';
    displaystring += '<div id="wantMoreResultsContainer">';
    displaystring += '<span style="text-align: center;">Not any of these? Want to know more?</span>';
    displaystring += '<button type="submit" id="clickToCallOpenAiAnswerButton" style="cursor:pointer;">Click here</button>';
    displaystring += '</div></div>';
    displaystring += '<div id="v3" style="display:none"><p id="openAiResults"></p><img id="showV1" src="' + chrome.runtime.getURL("icon/close.png") + '" width="50"></div>'
displaystring += '</div>';
    
    waitForTag("body", function() {
        // if (document.getElementById("PurpleLinks")) {
        //     var element = document.getElementById("PurpleLinks");
        //     element.parentNode.removeChild(element);
        // }

        if (document.getElementById("Y_Ext")) {
            var element = document.getElementById("Y_Ext");
            element.parentNode.removeChild(element);
        }
        // const elem = document.createElement('div')
        // elem.innerHTML = refresh_str
        // const target = document.getElementById('comments')
        // target.parentNode.insertBefore(elem, target)

        // document.getElementById("y_details").addEventListener("click", function() {
        //   document.getElementById("Y_Ext").classList.toggle("Y_Ext_2");
        //   if(d%2==0){
        //       document.getElementById("Y_Ext").style.animationName = "Y_Exta";
        //       if(result.isVideoSupported === false) {
        //         sendOpenCountExtensionInfoToTheServer();
        //       }
        //     }
        //     else{
        //       document.getElementById("Y_Ext").style.animationName = "Y_Exta_2";
        //     }
        //     d++;
        // });
        createpopup(displaystring, result);
        handletree("PurpleLinks_2");
    });
  }
}

function checkURLchange() {
  if (window.location.href != oldURL) {
    oldURL = window.location.href;
    if(window.location.href.startsWith("https://www.youtube.com")) {
      if(window.location.href.startsWith("https://www.youtube.com/watch?")) {
        getManifestVersionAndCallApi();
      } else {
        removeExtension();
      }
    } else {
      getManifestVersionAndCallApi();
    }
  }
}

function removeExtension() {
  if (document.getElementById("Y_Ext")) {
    var element = document.getElementById("Y_Ext");
    element.parentNode.removeChild(element);
  }
}

function getManifestVersionAndCallApi() {
  chrome.runtime.sendMessage({method: "getManifest"});
}

chrome.runtime.onMessage.addListener(function(msg, sender, sendResponse) {
  if(msg.manifest) {
    callapi(msg.manifest);
  }
  sendResponse(true);

});

if(window.location.href.startsWith("https://www.youtube.com")) {
  if(window.location.href.startsWith("https://www.youtube.com/watch?")) {
    getManifestVersionAndCallApi();
  } 
} else {
  getManifestVersionAndCallApi();
}

if (window.location.href) {
  var oldURL = window.location.href;
  setInterval(checkURLchange, 1000);
}

function waitForElement(id, callback) {
  var poops = setInterval(function() {
      if (document.getElementById(id)) {
          clearInterval(poops);
          callback();
      }
  }, 100);
}

function waitForTag(tag, callback) {
  var poops = setInterval(function() {
      if (document.getElementsByTagName(tag)) {
          clearInterval(poops);
          callback();
      }
  }, 100);
}

function handletree(idpar) {

  var toggler = document.querySelectorAll("#" + idpar + " .caret");
  var i;

  for (i = 0; i < toggler.length; i++) {
      toggler[i].addEventListener("click", function() {
          this.parentElement.querySelector(".nested").classList.toggle("active");
          this.classList.toggle("caret-down");
          this.parentElement.scrollIntoViewIfNeeded(false)
      });
  }
}

function createpopup(popstr, result) {
    d=0
  
  var popstr_2 = '';
  popstr_2 += '<div class="Y_Ext_container" id="Y_Ext_cpt">';
  popstr_2 += '<header class="Y_Ext_header" style="';
  popstr_2 += 'font-size: 24px;';
  popstr_2 += '">Video Hyperlinker';

  popstr_2 += '<span class="Y_Ext_close" style="margin-left: -20px"><img class="Y_Ext_close_img" src="' + chrome.runtime.getURL("icon/right-arrow-new.png") + '" width="50"></span>';
  popstr_2 += '</header>';
  popstr_2 += '<div class="Y_Ext_content"><span class="Y_Ext_hide" style="margin-left: -20px"><img class="Y_Ext_hide_img" src="' + chrome.runtime.getURL("icon/close-new.png") + '" width="50"></span>' + popstr + '<div id="searchTermsOnResultPage"><span><img id="" src=" ' +chrome.runtime.getURL("icon/loupe.png") + '" width="20" height="20"></span><input type="text" autocomplete="off" id="Anothersearch" placeholder="Type phrase e.g. nested list & Press enter"></div><div id="openFeedback">'+feedbackBox()+'<img id="openFeedbackBoxImg" src=" ' +chrome.runtime.getURL("icon/feedback.png") + '" width="30"><div id="closeAndSendButton"><img id="Y_Ext_feedback_close" src=" ' +chrome.runtime.getURL("icon/close-feedback.png") + '" width="25"><img id="Y_Ext_feedback-submit" src=" ' +chrome.runtime.getURL("icon/send.png") + '" width="25"></div></div>';
  popstr_2 += '</div>';

  if (!document.getElementById("Y_Ext")) {
      var elemDiv = document.createElement('div');
      elemDiv.id = "Y_Ext";
      elemDiv.classList.add("Y_Ext_2");
      document.body.appendChild(elemDiv);

      document.getElementById("Y_Ext").innerHTML = popstr_2;
      if(!result.message) {
        document.getElementById("Y_Ext").style.animationName = "Y_Exta_2";
      }

    if(document.getElementsByClassName("Y_Ext_close")[0]){
      document.getElementsByClassName("Y_Ext_close")[0].addEventListener("click", function() {

        document.getElementById("Y_Ext").classList.toggle("Y_Ext_2");
        if(d%2==0){
          if(document.querySelector('#referenceHeadingLoader .color'))document.querySelector('#referenceHeadingLoader .color').style.animationName="progress";
          document.getElementsByClassName("Y_Ext_close")[0].style.left="20px";
          document.getElementById("Y_Ext").style.animationName = "Y_Exta";

          document.getElementsByClassName('Y_Ext_hide')[0].style.top="20px"
          document.getElementsByClassName('Y_Ext_hide')[0].style.left="98%"
          if(result.isVideoSupported === false) {
            sendOpenCountExtensionInfoToTheServer(result.isVideoSupported);
          }
        }
        else{
          if(document.querySelector('#referenceHeadingLoader .color'))document.querySelector('#referenceHeadingLoader .color').style.animationName="";
          document.getElementById("Y_Ext").style.animationName = "Y_Exta_2";
          setTimeout(()=>{
            document.getElementsByClassName("Y_Ext_close")[0].style.left="0px";
            document.getElementsByClassName("Y_Ext_close")[0].style.transition="left 0.6s ease-out"
          },600)

          document.getElementsByClassName('Y_Ext_hide')[0].style.top="51px"
          document.getElementsByClassName('Y_Ext_hide')[0].style.left="9px"

        }
        d++;

    });
    }

     if(document.getElementsByClassName('Y_Ext_hide')[0]){
      document.getElementsByClassName('Y_Ext_hide')[0].addEventListener('click',function() {
        sendHideExtensionInfoToTheServer(result.isVideoSupported);
        document.getElementById('Y_Ext').style.display="none";
      });
     }

      if(document.getElementById("Y_Ext_feedback-submit")){
        document.getElementById("Y_Ext_feedback-submit").addEventListener("click", function() {
          var feedbackData = document.getElementById("Y_Ext_feedback").value;
          const openFeedback=document.getElementById('openFeedback');
          openFeedback.style.cssText="display: flex;margin: 20px auto;box-shadow: rgba(0, 0, 0, 0.3) 0px 10px 30px;width: max-content;";
          if(feedbackData) {
            openFeedback.style.paddingBottom="10px";
            // document.getElementById("Y_Ext_feedback_Container").style.display = "none";
  // document.getElementById("Y_Ext_feedback-submit").style.display="none";
            document.getElementById('closeAndSendButton').style.top="-10px";
            document.getElementById('closeAndSendButton').style.right="70px";
            document.getElementById("Y_Ext_feedback_success").style.display = "block";
            document.getElementById("Y_Ext_feedback_Container").style.display = "none";
            document.getElementById("Y_Ext_feedback-submit").style.display="none";
            document.getElementById("Y_Ext_feedback").value="";
            const urlParams = new URLSearchParams(window.location.search);
            var postrequestOptions = {
              method:'POST',
              redirect: "follow",
              headers: {
                'Accept': 'application/json',
                'Content-Type': 'application/json'
              },
              body:JSON.stringify(
                {
                  rating: 3,
                  comment: feedbackData,
                  personEmail: '',
                  personName: '',
                  userType: 'extension',
                  currentPageUrl: window.location.href,
                  currentPageName: urlParams.get('v'),
                  currentPostBody: JSON.stringify({}),
                  sourcePostBody: JSON.stringify({}),
                  sourceUrl: '',
                  cookieId: ''
                }
              )
            };
            fetch("https://edutestqa.appspot.com/admin/content/api/v1/feedback", postrequestOptions)
              .then(response => response.text())
              .then(result => clearFeedbackArea('Y_Ext_feedback'))
              .catch(error => console.log('error', error));
          } else {
            const openFeedback=document.getElementById('openFeedback');
            openFeedback.style.paddingBottom="20px";
            document.getElementById("Y_Ext_feedback").focus();
            document.getElementById("Y_Ext_feedback_error").style.display = "block";
          }
          
        });
      }

      if(document.getElementById("Y_Ext_feedback")){
        document.getElementById("Y_Ext_feedback").addEventListener("input", function() {
          if(this.value!==''){
            console.log("not empty");
            document.getElementById("Y_Ext_feedback_error").style.display = "none";
            const openFeedback=document.getElementById('openFeedback');
            openFeedback.style.paddingBottom="10px";
            document.getElementById('Y_Ext_feedback-submit').setAttribute('src',chrome.runtime.getURL("icon/send-on-input.png"))
          }
          else{
            console.log("empty");
            document.getElementById('Y_Ext_feedback-submit').setAttribute('src',chrome.runtime.getURL("icon/send.png"))
          }
        });
      }

     if(document.getElementById('userInputTerms')){
      document.getElementById('userInputTerms').addEventListener("keyup", function(event) {
        if (this.value !=='' && event.code === 'Enter') {
          document.getElementById('v1').style.display="none";
          document.getElementById('v2').style.display="block";
          document.getElementById('searchTermsOnResultPage').style.display="flex";
          document.getElementById('openFeedback').style.padding="0px";
          document.getElementById('openFeedbackBoxImg').style.right="6px";
          var keys=Object.keys(result.purpleLinksInfoExtFull);
          var anotherSearchTerm="";
          for (var i = 0; i < keys.length; i++) {
            var key = keys[i];
            if (result.purpleLinksInfoExtFull.hasOwnProperty(key)) {
              anotherSearchTerm+=(result.purpleLinksInfoExtFull[key]["purpleLinkPhrase"].split("\n")[1]).trim()+",";
            }
        }
        testTheSearch(anotherSearchTerm,this.value,result);
        this.value="";
        }
    });
     }

 if(document.getElementById('Anothersearch')){
  document.getElementById('Anothersearch').addEventListener("keyup", function(event) {
    if (this.value !=='' && event.code === 'Enter') {
      document.getElementById('v1').style.display="none";
      document.getElementById('v2').style.display="block";
      document.getElementById('openFeedback').style.padding="0px";
      document.getElementById('openFeedbackBoxImg').style.right="6px";
      var keys=Object.keys(result.purpleLinksInfoExtFull);
      var anotherSearchTerm="";
      for (var i = 0; i < keys.length; i++) {
        var key = keys[i];
        if (result.purpleLinksInfoExtFull.hasOwnProperty(key)) {
          anotherSearchTerm+=(result.purpleLinksInfoExtFull[key]["purpleLinkPhrase"].split("\n")[1]).trim()+",";
        }
    }
    testTheSearch(anotherSearchTerm,this.value,result);
    this.value="";
    }
});
 }


     if(document.getElementById('clickToCallOpenAiAnswerButton')){
      document.getElementById('clickToCallOpenAiAnswerButton').addEventListener("click",function() {
        document.getElementById('v2').style.display="none";
        document.getElementById('v3').style.display="block";
        document.getElementById('searchTermsOnResultPage').style.display="flex";
      });
     }

      if(document.getElementById('showV1')){
        document.getElementById('showV1').addEventListener("click",function() {
          document.getElementById('filteredResultsContainer').remove();
          document.getElementById('v1').style.display="block";
          document.getElementById('v3').style.display="none";
          document.getElementById('referenceHeading').style.display="block ";
          document.getElementById('referenceHeading').innerHTML="Want to know more about a term in the video?";
        });
      }
      
  if(document.getElementById('openFeedbackBoxImg')){
    document.getElementById('openFeedbackBoxImg').addEventListener('click',function() {
      if(document.getElementById('Y_Ext_feedback').value!==''){
        console.log("not empty");
        document.getElementById('Y_Ext_feedback-submit').setAttribute('src',chrome.runtime.getURL("icon/send-on-input.png"));
      }
      else{
        console.log("empty");
        document.getElementById('Y_Ext_feedback-submit').setAttribute('src',chrome.runtime.getURL("icon/send.png"));
      }
      const openFeedback=document.getElementById('openFeedback');
      openFeedback.style.cssText="margin: 20px auto 20px;box-shadow: 0px 10px 30px rgba(0,0,0,0.3);width: max-content;display:flex;";
      document.getElementById("Y_Ext_feedback-submit").style.display="block";
      const Y_Ext_feedback_container =document.getElementsByClassName('Y_Ext_feedback-container')[0];
      Y_Ext_feedback_container.style.display="flex";
      const closeAndSendButton=document.getElementById('closeAndSendButton');
      this.style.display="none";
      closeAndSendButton.style.display="flex";
      closeAndSendButton.style.top="0px";
      closeAndSendButton.style.right="0px";
      // if(Y_Ext_feedback_container.style.display=="flex")
      //     Y_Ext_feedback_container.style.display="none";
      // else
      //     Y_Ext_feedback_container.style.display="flex";
    });
  }

      // if( document.getElementById('Y_Ext_feedback')){
      //   document.getElementById('Y_Ext_feedback').addEventListener('input',function() {
      //     if(this.value!==''){
      //       console.log("not empty");
      //       const openFeedback=document.getElementById('openFeedback');
      //       openFeedback.style.paddingBottom="10px";
      //       document.getElementById('Y_Ext_feedback-submit').setAttribute('src',chrome.runtime.getURL("icon/send-on-input.png"))
      //     }
      //     else{
      //       console.log("empty");
      //       document.getElementById('Y_Ext_feedback-submit').setAttribute('src',chrome.runtime.getURL("icon/send.png"))
      //     }
      //   });
      // }

     if( document.getElementById("Y_Ext_feedback_close")){
      document.getElementById("Y_Ext_feedback_close").addEventListener("click", function() {
        document.getElementById("Y_Ext_feedback_success").style.display = "none";
        document.getElementById("closeAndSendButton").style.display = "none";
        document.getElementById("Y_Ext_feedback_Container").style.display = "none";
        document.getElementById('openFeedbackBoxImg').style.cssText="display:block;right:25px";
        document.getElementById("Y_Ext_feedback_error").style.display = "none";
        const openFeedback=document.getElementById('openFeedback');
        openFeedback.style.cssText="width: 100%;box-shadow: none;margin: auto;display:block;padding-bottom:10px";
      });
     }
  }

}

var d=0

function feedbackBox() {
  let feedback_string = '<div class="Y_Ext_feedback-container" id="Y_Ext_feedback_Container">';
  feedback_string += '<textarea id="Y_Ext_feedback" name="feedback" cols="30" rows="3" placeholder="If you have a message or feedback, please type here.." style="resize:none;"></textarea>';
  // feedback_string += '<input class="Y_Ext_vertical-center" type="submit" value="Submit" id="Y_Ext_feedback-submit" style="cursor:pointer;">';
  feedback_string += '</div><p id="Y_Ext_feedback_error" style="display:none; font-size: medium; color:black;font-weight:bold">* Please type a message before submitting</p><br>';
  feedback_string += '<div style="display:none;" id="Y_Ext_feedback_success" class="Y_Ext_feedback_success">';
  // feedback_string += '<img class="Y_Ext_close_img" id="Y_Ext_feedback_close" style="float:right; cursor:pointer;" src="' + chrome.runtime.getURL("icon/close-new.png") + '" width="10" height="10">';
  feedback_string += '<span class="Y_Ext_feedback_success_message">Thank you!<br>We have received your feedback.</span>'
  feedback_string += '</div><br>';
  return feedback_string;
}

function clearFeedbackArea(feedbackTextareaId) {
  // document.getElementById(feedbackTextareaId).value = '';
  
  // document.getElementById("Y_Ext_feedback_close").addEventListener("click", function() {
  //   document.getElementById("Y_Ext_feedback_success").style.display = "none";
  //   document.getElementById("closeAndSendButton").style.display = "none";
  //   document.getElementById("Y_Ext_feedback_Container").style.display = "none";
  //   document.getElementById('openFeedbackBoxImg').style.display="block";
  //   document.getElementById("Y_Ext_feedback_error").style.display = "none";
  //   const openFeedback=document.getElementById('openFeedback');
  //       openFeedback.style.cssText="width: 100%;box-shadow: none;margin: auto -10px 20px;";
  // });
}

function sendOpenCountExtensionInfoToTheServer(isVideoSupported) {
  const url = window.location.href;
  var body = {
    "videoIdData": {}
  }
  body["videoIdData"][url] = {
    "openExtensionCount": 1,
    "videoSupported": isVideoSupported
  };
  var postrequestOptions = {
    method:'POST',
    redirect: "follow",
    headers: {
      'Accept': 'application/json',
      'Content-Type': 'application/json'
    },
    body:JSON.stringify(body)
  }
  fetch("https://edutestqa.appspot.com/admin/content/api/v1/logExtensionInfo",postrequestOptions)
    .then(res=>res.json())
    .then((data)=>console.log(data))
    .catch(error => console.log('error', error));

}

function sendHideExtensionInfoToTheServer(isVideoSupported) {
  const url = window.location.href;
  var body = {
    "videoIdData": {}
  }
  body["videoIdData"][url] = {
    "hideExtensionClickCount": 1,
    "videoSupported": isVideoSupported?isVideoSupported:true
  };
  var postrequestOptions = {
    method:'POST',
    redirect: "follow",
    headers: {
      'Accept': 'application/json',
      'Content-Type': 'application/json'
    },
    body:JSON.stringify(body)
  }
  fetch("https://edutestqa.appspot.com/admin/content/api/v1/logExtensionInfo",postrequestOptions)
    .then(res=>res.json())
    .then((data)=>console.log(data))
    .catch(error => console.log('error', error));

}


function fetchOpenAiData(searchedTerm){
  var body = {
    "searchTerm":searchedTerm
  }
  var postrequestOptions = {
    method:'POST',
    redirect: "follow",
    headers: {
      'Accept': 'application/json',
      'Content-Type': 'application/json'
    },
    body:JSON.stringify(body)
  }
  fetch("https://edutestqa.appspot.com/admin/content/api/v1/answer",postrequestOptions)
    .then(res=>res.json())
    .then((data)=>{document.getElementById('openAiResults').innerHTML= data.message})
    .catch(error => console.log('error', error));
}





/*-----------------jaro.js-------------------------------*/

function apply(left, right) {
  var defaultScalingFactor = 0.1;

  if (left == null || right == null) {
      console.log("left & right must not be null");
  }

  var mtp = matches(left, right);
  var m = mtp[0];
  if (m == 0) {
      return 0.0;
  }

  var j = ((m / left.length + m / right.length + (m - mtp[1] / 2) / m)) / 3.0;
  var jw = j < 0.7 ? j : j + defaultScalingFactor * mtp[2] * (1 - j);
  return jw;
}

function matches(first, second) {
  var max, min;
  if (first.length > second.length) {
      max = first;
      min = second;
  } else {
      max = second;
      min = first;
  }
  var range = Math.max(max.length / 2 - 1, 0);
  var matchIndexes = new Array(min.length);
  matchIndexes.fill(-1);
  var matchFlags = new Array(max.length);
  var matches = 0;
  for (var mi = 0; mi < min.length; mi++) {
      var c1 = min.charAt(mi);
      for (var xi = Math.max(mi - range, 0), xn = Math.min(mi + range + 1, max.length); xi < xn; xi++) {
          if (!matchFlags[xi] && c1 == max.charAt(xi)) {
              matchIndexes[mi] = xi;
              matchFlags[xi] = true;
              matches++;
              break;
          }
      }
  }
  var ms1 = new Array(matches);
  var ms2 = new Array(matches);
  for (var i = 0, si = 0; i < min.length; i++) {
      if (matchIndexes[i] != -1) {
          ms1[si] = min.charAt(i);
          si++;
      }
  }
  for (var i = 0, si = 0; i < max.length; i++) {
      if (matchFlags[i]) {
          ms2[si] = max.charAt(i);
          si++;
      }
  }
  var halfTranspositions = 0;
  for (var mi = 0; mi < ms1.length; mi++) {
      if (ms1[mi] != ms2[mi]) {
          halfTranspositions++;
      }
  }
  var prefix = 0;
  for (var mi = 0; mi < Math.min(4, min.length); mi++) {
      if (first.charAt(mi) == second.charAt(mi)) {
          prefix++;
      } else {
          break;
      }
  }
  return [matches, halfTranspositions, prefix];
}

/*------------------jaro.js ends -------------------*/

/*------------------index.js starts ---------------*/

const DIFF_LEN_RATIO_THRESHOLD = 0.8;
const PREFIX_MATCH_RATIO_THRESHOLD = 0.8;
const FUZZY_MATCH_THRESHOLD = 0.8;
    
const PARTIAL_MATCH_THRESHOLD = 0.0;

function getDiffLenRatio(str1, str2) {
    var lenDiff = Math.abs(str1.length - str2.length);
    var maxLen = Math.max(str1.length, str2.length);
    return lenDiff / maxLen;
}

function getCommonPrefixLength(str1, str2) {
    var minLength = Math.min(str1.length, str2.length);
    var commonPrefixLength = 0;
    for (var i = 0; i < minLength; i++) {
        if (str1.charAt(i) != str2.charAt(i)) {
            break;
        }
        commonPrefixLength++;
    }
    return commonPrefixLength;
}

function isPrefixMatch(str1, str2, diffLenRatio) {
    // Convert strings to lowercase
    str1 = str1.toLowerCase();
    str2 = str2.toLowerCase();

    if (str1 === str2) {
        return true;
    }
    
    var commonPrefixLength = getCommonPrefixLength(str1, str2);
    var z = parseInt(PREFIX_MATCH_RATIO_THRESHOLD * Math.min(str1.length, str2.length));

    if (diffLenRatio < DIFF_LEN_RATIO_THRESHOLD && commonPrefixLength >= z) {
        return true;
    }

    // No match found, consider the strings as not duplicates
    return false;
}

function getAllRelatedMatches(str1, str2, diffLenRatio, partialMatchScore) {
    // Convert strings to lowercase
    str1 = str1.toLowerCase();
    str2 = str2.toLowerCase();

    // Check for exact match
    if (str1 === str2) {
        return true;
    }

    // Check for prefix match
    if (isPrefixMatch(str1, str2, diffLenRatio) || isPrefixMatch(str2, str1, diffLenRatio)) {
        return true;
    }
    
    // Check for the match in the string
    if (str1.includes(str2) || str2.includes(str1)) {
        return true;
    }
    // Check for fuzzy match
    if (partialMatchScore > PARTIAL_MATCH_THRESHOLD) {
        return true;
    }

    // No match found, consider the strings as not duplicates
    return false;
}

function getPartialMatchScore(string1, string2) {
    string1 = removeStopWordsFromTerm(string1);
    string2 = removeStopWordsFromTerm(string2);

    var string1Array = string1.split(" ");
    var string2Array = string2.split(" ");

    if(string2Array.length < string1Array.length) {
        return findSimilarityScore(string1Array, string2Array);
    } else {
        return findSimilarityScore(string2Array, string1Array);
    }
}

function removeStopWordsFromTerm(term) {
    var stopwords = loadStopwords();
    var termArray = term.toLowerCase().split(" ");
    termArray = termArray.filter(function (item) { // check each item against existingIds, and if not found there return it
        return stopwords.indexOf(item) === -1;
    });
    term = termArray.join(" ");
    return term;
}

function loadStopwords() {

    // Read stopwords from the file
    // fetch('https://edutestqa.appspot.com/assets/files/stopwords.txt', {mode: 'no-cors'})
    //  .then(response => response.text())
    //  .then(data=> console.log(data))
    //  .catch(error => console.error(error));
    
     var fileData = ["a","able","about","above","according","accordingly","across","actually","after","afterwards","again","against","ain't","all","allow","allows","almost","alone","along","already","also","although","always","am","among","amongst","an","and","another","any","anybody","anyhow","anyone","anything","anyway","anyways","anywhere","apart","appear","appreciate","appropriate","are","aren't","around","as","a's","aside","ask","asking","associated","at","available","away","awfully","be","became","because","become","becomes","becoming","been","before","beforehand","behind","being","believe","below","beside","besides","best","better","between","beyond","both","brief","but","by","came","can","cannot","cant","can't","cause","causes","certain","certainly","changes","clearly","c'mon","co","com","come","comes","concerning","consequently","consider","considering","contain","containing","contains","corresponding","could","couldn't","course","c's","currently","definitely","described","despite","did","didn't","different","do","does","doesn't","doing","don","done","don't","down","downwards","during","each","edu","eg","eight","either","else","elsewhere","enough","entirely","especially","et","etc","even","ever","every","everybody","everyone","everything","everywhere","ex","exactly","example","except","far","few","fifth","first","five","followed","following","follows","for","former","formerly","forth","four","from","further","furthermore","get","gets","getting","given","gives","go","goes","going","gone","got","gotten","greetings","had","hadn't","happens","hardly","has","hasn't","have","haven't","having","he","he'd","he'll","hello","help","hence","her","here","hereafter","hereby","herein","here's","hereupon","hers","herself","he's","hi","him","himself","his","hither","hopefully","how","howbeit","however","how's","i","i'd","ie","if","ignored","i'll","i'm","immediate","in","inasmuch","inc","indeed","indicate","indicated","indicates","inner","insofar","instead","into","inward","is","isn't","it","it'd","it'll","its","it's","itself","i've","just","keep","keeps","kept","know","known","knows","last","lately","later","latter","latterly","least","less","lest","let","let's","like","liked","likely","little","look","looking","looks","ltd","mainly","many","may","maybe","me","mean","meanwhile","merely","might","more","moreover","most","mostly","much","must","mustn't","my","myself","name","namely","nd","near","nearly","necessary","need","needs","neither","never","nevertheless","new","next","nine","no","nobody","non","none","noone","nor","normally","not","nothing","novel","now","nowhere","obviously","of","off","often","oh","ok","okay","old","on","once","one","ones","only","onto","or","other","others","otherwise","ought","our","ours","ourselves","out","outside","over","overall","own","particular","particularly","per","perhaps","placed","please","plus","possible","presumably","probably","provides","que","quite","qv","rather","rd","re","really","reasonably","regarding","regardless","regards","relatively","respectively","right","s","said","same","saw","say","saying","says","second","secondly","see","seeing","seem","seemed","seeming","seems","seen","self","selves","sensible","sent","serious","seriously","seven","several","shall","shan't","she","she'd","she'll","she's","should","shouldn't","since","six","so","some","somebody","somehow","someone","something","sometime","sometimes","somewhat","somewhere","soon","sorry","specified","specify","specifying","still","sub","such","sup","sure","t","take","taken","tell","tends","th","than","thank","thanks","thanx","that","thats","that's","the","their","theirs","them","themselves","then","thence","there","thereafter","thereby","therefore","therein","theres","there's","thereupon","these","they","they'd","they'll","they're","they've","think","third","this","thorough","thoroughly","those","though","three","through","throughout","thru","thus","to","together","too","took","toward","towards","tried","tries","truly","try","trying","t's","twice","two","un","under","unfortunately","unless","unlikely","until","unto","up","upon","us","use","used","useful","uses","using","usually","value","various","very","via","viz","vs","want","wants","was","wasn't","way","we","we'd","welcome","well","we'll","went","were","we're","weren't","we've","what","whatever","what's","when","whence","whenever","when's","where","whereafter","whereas","whereby","wherein","where's","whereupon","wherever","whether","which","while","whither","who","whoever","whole","whom","who's","whose","why","why's","will","willing","wish","with","within","without","wonder","won't","would","wouldn't","yes","yet","you","you'd","you'll","your","you're","yours","yourself","yourselves","you've","zero"];
     return fileData;
}

function findSimilarityScore(str1, str2) {
    var score = 0.0;

    // create a set
    const wordsCompared = new Set();

    var wordMatchCounter = 0.0;
    for (var s1Word of str1) {
        var jaro_distance = 0.0;
        for (var s2Word of str2) {
            jaro_distance = apply(s1Word, s2Word);
            if (jaro_distance >= 0.87) {
                wordMatchCounter++;
            }
            wordsCompared.add(s1Word);
            wordsCompared.add(s2Word);
        }
    }

    score = wordMatchCounter/wordsCompared.size;
    return score;
}

/*-------------------index.js ends-------------------------*/

/*-------------------test.js------------------------------*/

function testTheSearch(testTermSet, testSearchTerm, result) {
	var setArray = testTermSet.split(",");
	var resultMap = calculateAbsoluteScore(testSearchTerm, setArray);
  var keys = Object.keys(result.purpleLinksInfoExtFull);
  var displaystring='';
  let foundResult=false;

  var purpleLinks = getSupportedPurpleLink(result.purpleLinksInfoExtFull, resultMap);
	if(purpleLinks && purpleLinks.length > 0) {
    var purpleLinkResults = getPurpleLinkResultsBasedOnScoreDesc(purpleLinks);
    if(purpleLinkResults && purpleLinkResults.length > 0) {
      purpleLinkResults = removePurpleLinkResultsDuplicates(purpleLinkResults);
      foundResult=true;
      for (var counter = 0; counter < purpleLinkResults.length; counter++) {
        displaystring += '<li>';
        displaystring += '<div class="purpleLinkPhrase_sH">';
        displaystring += '<a target="_blank" href="' + purpleLinkResults[counter]["url"] + '">' + purpleLinkResults[counter]["sH"] + '</a>';
        displaystring += '</div>';
        displaystring += '</li>';
      }
      displaystring += '</ul>';
      displaystring += '</li>';
    }
  }

  if(foundResult){
    document.getElementById('referenceHeading').style.display="block";
    document.getElementById('referenceHeading').innerHTML=`For explanation from author on <strong id="searcheduserterm">"${testSearchTerm}"</strong>, click below`;
    if(result.isOpenAiAnswerSupported){
      document.getElementById('wantMoreResultsContainer').style.display="block";
    }
    else{
      document.getElementById('wantMoreResultsContainer').style.display="none";
      fetchOpenAiData(this.value);
    }
  }

  else{
    if(result.isOpenAiAnswerSupported){
      document.getElementById('v3').style.display="block";
      document.getElementById('v2').style.display="none";
      document.getElementById('searchTermsOnResultPage').style.display="flex";
      fetchOpenAiData(this.value);
    }
    else{
      document.getElementById('referenceHeading').style.display="none ";
      displaystring=`Unfortunately,<span style="font-style:italic;font-weight:400">"${testSearchTerm}"</span> is not explained in any video by the author`;
      document.getElementById('wantMoreResultsContainer').style.display="none";
    }
  }
  var filteredResultsContainer=document.createElement('div');
  filteredResultsContainer.id="filteredResultsContainer";
  document.getElementById('matchedPurpleLinkResults').appendChild(filteredResultsContainer);
  document.getElementById('filteredResultsContainer').innerHTML=displaystring;
}

function getSupportedPurpleLink(purpleLinksInfoExtFull, resultMap) {
  var supportedPurpleLink = [];
  var supportedKeywords = Array.from(resultMap.keys());
  var keys = Object.keys(purpleLinksInfoExtFull);
  for(var i = 0; i < keys.length; i++) {
    var key = keys[i];
    var purpleLink = purpleLinksInfoExtFull[key];
    var purpleLinkPhrase = purpleLink["purpleLinkPhrase"].split("\n")[1].trim();
    if(supportedKeywords.includes(purpleLinkPhrase) && resultMap.get(purpleLinkPhrase) > 0) {
      purpleLink["score"] = resultMap.get(purpleLinkPhrase);
      supportedPurpleLink.push(purpleLink);
    }
  }
  return supportedPurpleLink;
}

function getPurpleLinkResultsBasedOnScoreDesc(purpleLinks) {
  var supportedPurpleLinkResults = [];
  for(var i = 0; i < purpleLinks.length; i++) {
    var purpleLink = purpleLinks[i];
    var purpleLinkData = purpleLink["data"];
    for(var j = 0; j < purpleLinkData.length; j++) {
      var purpleLinkResult = purpleLinkData[j];
      if(purpleLinkResult["score"]) {
        purpleLinkResult["score"] = purpleLinkResult["score"] * purpleLink["score"];
      } else {
        purpleLinkResult["score"] = purpleLink["score"];
      }
      supportedPurpleLinkResults.push(purpleLinkResult);
    }
  }
  supportedPurpleLinkResults.sort((a,b) => { 
    return b.score - a.score; 
  });
  return supportedPurpleLinkResults;
}

function removePurpleLinkResultsDuplicates(purpleLinkResults) {
  var unique = [];
  var uniquePurpleLinkResults = [];
  purpleLinkResults.forEach(purpleLinkResult => {
    var sectionHierarchy = purpleLinkResult["sH"];
    sectionHierarchy = sectionHierarchy.trim().toLowerCase();
    if (!unique.includes(sectionHierarchy)) {
      unique.push(sectionHierarchy);
      uniquePurpleLinkResults.push(purpleLinkResult);
    }
  });
  return uniquePurpleLinkResults;
}

function jaroScore(str1, str2) {
	str1 = str1.trim().toLowerCase();
	str2 = str2.trim().toLowerCase();

	str1 = removeStopWordsFromTerm(str1);
    str2 = removeStopWordsFromTerm(str2);

    return apply(str1, str2);
}

function calculateAbsoluteScore(term, setArray) {
	var closestMatchMap = new Map();
	var matchAndDiffLengthMap = new Map();
	for(var termFromSet of setArray) {
		var score = getPartialMatchScore(termFromSet.trim(), term.trim());
		var diffLenRatio = getDiffLenRatio(termFromSet.trim(), term.trim());
		if (getAllRelatedMatches(term.trim(), termFromSet.trim(), diffLenRatio, score)) {
			closestMatchMap.set(termFromSet.trim(), score);
			matchAndDiffLengthMap.set(termFromSet.trim(), diffLenRatio);
		}
	}
	closestMatchMap = new Map([...closestMatchMap.entries()].sort((a, b) => {
		if(b[1] - a[1] == 0) {
			var diffLenRatio1 = matchAndDiffLengthMap.get(a[1]);
            var diffLenRatio2 = matchAndDiffLengthMap.get(b[1]);
            return diffLenRatio2 - diffLenRatio1;
		} else {
			return b[1] - a[1];
		}
	}));
	return closestMatchMap;
}


/*----------------------------test.js ends-----------------*/